# Machine Design

jake: ctrl+f TODO

## Intro

*Machines in a week*  
*It's easy, so to speak*   
*In minutia is mayhem*  

OK, welcome to Machine Week.  

If you're reading this, chances are you're about to design a machine, and then build it, and then 'bring it online', and then do something with it. Exciting! There's a great deal of complexity here! I have done this a few times now<sup>1</sup>, and every time it's a new adventure.  

This document will serve as a guide for how to make (almost) a fairly standard 3-axis machine. *!ALERT! ~ This is a design process ~ !ALERT!* so please bear with any ambiguities, and the inherent nonlinearities present. For example, I already have a machine in mind, that I want to build (for reasons) - you may have an entirely different type of machine in mind, for different reasons. When possible, I will take asides to explain my reasoning<sup>2</sup>, but overall, I intend this to be (1) a guide - for how to build this machine or slight deviations thereof, and (2) an exposition on (almost) how I go about considering machine design. Mostly, I hope to demystify CNC D&B<sup>3</sup>  

### In this order, we will do:

#### Design:
 - Draw a Layout (Rhino Suggested)
 - Detail the Axis
 - Detail Interconnects

#### Manufacturing:
 - Do Material Layout in Rhino
 - Program CAM in Fusion
 - Do the Milling

#### Assembly:
 - Put it together!
 - Alignment, alignment, alignment!

#### Electronics Assembly:
 - Plugs, Switches, Power, oh my!

#### Motion Control 
 - TinyG with a Big Heart (and minimum acceleration!)

#### Machine Communication
 - Beaglebone w/ Replicape
 - Chilipeppr 
 - Learning about GCode

#### End Effectors
 - Open Season: Design your own!

## Layout 

First thing, you'll want to get a hang of what rough sizes / shapes / orientations your machine is going to have. In this case, I'm interested in designing something of an 'everything machine'. I.E it should be useful for a few different processes: 3D Printing, CNC Milling, Flat-Sheet Cutting (a-la the ZUND), and (maybe) eventually Laser Cutting. Normally I would not advise this<sup>4</sup>, but here we are.  

I'm going to aim at a roundabout bed-size<sup>5</sup> of 12x24"<sup>6</sup> - largely this just feels like a happy medium between large format and small format work. It's a fairly common size for sheet stock, or at least bigger sheet stock can be broken down into these sizes with minimum work. In Europe, sheets also commonly come in 1250x2500mm stock - a factor of 1.025 over the NA 4'x8' standard. I'm going to add 1" to each of these dimensions to account for that, and for general design-fudge-space, and for fixturing. I feel like 5'<sup>7</sup>is a great Z-travel value - will handle lots of stock, and lots of tools (in milling) - also, this is relative movement, and I plan on making the overall bed height / end-effector mount locations somewhat adjustable.  

SO: 13x25x5" moving area.  

W/R/T Layout, there are a number of permutations of how to go about adding axis together in order to get 3D motion. I'd like to cover a few of these in examples, and I'll leave a TODO here: - bridgeport x-on-y with beefy-z style, shopbot and laser 'H' machine w/ dual y-drive (note laser BED moves, not head), omax and fablight 'drafting-square' hella-stiffness gantries, ultimaker t-config, corexy, flexural stages. I really like [this machine](http://archive.fabacademy.org/2017/fablabverket/students/100/web/projects/diy_cnc/index.html) developed by one of Jens' students. I should explain why<sup>8</sup>. OK, enough talk - let's see an example of a machine layout - 

I tend to 'work out' from the Z-axis, towards the edges - this way I can keep track of where I need extra offsets (length of travel != length of gantry). Here's the layout with the Z-and-X axis group moved around to the extents.

![machine layout extents](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/layout-extents.jpg)

And the layout as representative of a real machine...

![machine layout](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/layout-machine.jpg)

This is all just loosely blocked out, in this stage I am really trying to get good numbers for the lengths of all of the axis, etc. Now I'll get into the actual Axis detailing. 

## Parametric Axis

Jens Dyvik is on some [wonderful machine building sprials (link!)](https://github.com/fellesverkstedet/fabricatable-machines) and we're going to put them to work this week. In particular, the [chamferrail system](https://github.com/fellesverkstedet/fabricatable-machines/tree/master/chamferrail). Take a look at his documentation to get an overview of the machines! 

I'm using his Chamferrail Generator in Rhino and Grasshopper - included in this repo under /cad/axis-generator/ and in [Jen's Repo here](https://github.com/fellesverkstedet/fabricatable-machines/tree/master/humphrito-medium-format-cnc). Now that I have my axis lengths laid out, I'll generate the axis, and go through the process of milling them. I'll do this first on the X Axis and circle back to make any adjustments to the system I see fit!

![generating the x axis](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/generate-x-axis.jpg)

Use Grasshopper to adjust the parameters - you'll find them all on the left. There's a huge swath to get through, use my files in /cad/axis-generator/ to get started as this is set up for what we have on hand in HTMAA. 

Now I use the 'bake' command to pull the geometry out of grasshopper and into Rhino.

![generating the x axis](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/generate-x-axis-bake.jpg)

- Observations on Build
 - Tricky to coordinate X / Z Axis as rails really need to be adjustable
 - Setting Z Height and Thicknesses during fab is VERY important! Face your Bed!
 - Countersink Bolts for Motor Mount, or bring hole size down so that you can tap
 - Bring Motor Flange Hole size ++
 - Bring Motor Mount Screws -- to thread

## Axis Blocks

- Connect ur axis
- Bringing layout & detail design together
- It's almost as if I knew about this system while I was doing layout! *~!NONLINEARITYALERT!~* 

## Doing the Milling

Once I'm ready to do some manufacturing, I start by laying the pieces out - grouping them by material. Most things are in HDPE (or ABS - TBD!). The 'rails' are made with Delrin<sup>9</sup> of a similar thickness, and the pinon is made of thicker Delrin, about 3/4". Here's a chance to optimize your layout for the size of sheet stock you have. Keep in mind you'll want clearance between items for cutout tools, etc.

![laying out the x axis](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/generate-x-axis-layout.jpg)

Now I brought this into Fusion to do some CAM. From Rhino, select the geometry for one material and Export as a *.step* file. Then you can upload this into Fusion.

![generating the x axis](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/machine-x-axis-setup.jpg)

I go to the CAM section right away, and setup some stock. First thing, our Shopbots are setup in Inches, so check that in the 'units' in the top of the tree. I'll use a 0" offset on top of the model, 0.05" on the bottom (then we can be sure to cut through later on) and a 0.75" offset on the sides - I want to be sure to clear the screws I'll be using to fixture my HDPE sheet.

For tools, I set up with a 1/8" 'O-Cutter' - as in, one flute. This is going to be my detail workhorse - it'll cut teeth and holes. I also have 1/4" O-Cutter to do profiles and cutouts. My two other tools are a Chamfer Endmill, used for, well, the chamfers, and a 1/16" 2-flute endmill for some detailing on the pinion. Here's a quick table of the tools, and their feeds and speeds. I used [the CBA Feeds and Speeds Calculator](https://pub.pages.cba.mit.edu/feed_speeds/) to ballpark these, and I'll dial them in as I test the first axis.  

A note on plastics - TODO heat, why single flute, sharp bits, what chips should look like

#### HDPE: 

Type | Flutes | Diameter | What For | Feed, XY (IPM) | Feed, Plunge (IPM) | Spindle Speed (RPM)
--- | --- | --- | --- | --- | --- | ---
Endmill | 1 | 1/8" | Most Details, Holes | 55 | 25 | 13500
Endmill | 1 | 1/4" | Cutouts, Grunt | 55 | 25 | 7000 
Endmill | 2 | 1/16" | Pinion Detail | 75 | 25 | 20000
Chamfer Mill | 2 | 1/2" | Rail Edges | 100 | 50 | 5000 

#### Acetal: 

Type | Flutes | Diameter | What For | Feed, XY (IPM) | Feed, Plunge (IPM) | Spindle Speed (RPM)
--- | --- | --- | --- | --- | --- | ---
Endmill | 1 | 1/8" | Most Details, Holes | 55 | 25 | 13500
Endmill | 1 | 1/4" | Cutouts, Grunt | 55 | 25 | 7000 
Endmill | 2 | 1/16" | Pinion Detail | 75 | 25 | 20000
Chamfer Mill | 2 | 1/2" | Rail Edges | 100 | 50 | 5000 

I also have a tool library for Fusion 360, include TODO here.  

The quality of your work on the Shopbot will directly influence the quality of work your CNC Machine will do! A few important points: 
 - Face your Bed!
  - The chamferrail system relies on a consistent chamfer size. If your bed is slightly tilted in any direction, the size of the chamfer will change along the length of the cut. This means that along some sections of the rail there will be too much friction, and at others, it will be lose!.
 - Carefully Zero the Z!
  - Same as above, thicknesses of varying parts are vary (haha) important. Rather than using the shopbot's z-touchoff plate, I like to dial the Z in myself by dropping the height in 0.1 -> 0.01 -> 0.002 increments, while checking if the tip of the bit is scoring an edge on the material.

![milling teeth](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/milling-teeth.gif)

![milling chamfers](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/milling-chamfer.gif)

## Assembly
- Careful on Blocks! Trim and Align
- 

## Plugging in Motors
- Coils are connected
- One and two
- Link Datasheet from StepperOnline

## Configuring TinyG
- https://github.com/synthetos/TinyG/wiki
- Do Power to the board
- Should enumerate on a serial port
- Use https://github.com/synthetos/TinyG/wiki/TinyG-TG-Updater-App to flash new firmware
 - Make sure you don't have the serial port open anywhere else
- Now complete setup
- Open in a serial terminal (Arduino has one built in, or see Neil for links) TODO

![its alive](https://gitlab.cba.mit.edu/jakeread/machineweek/raw/master/images/axis-moving.gif)

## Chilipepper
- It's Rad
- Like Mods, Chilipeppr uses a local serial server to pass messages from the browser to your serial port.
- Download the Serial Port Json Server after configuring TinyG
- http://chilipeppr.com/tinyg
- Steps / mm
- Acceleration
- Travel, etc

## Talking to, loading firmware on, TinyG
- Arduino, I hope?
- Chilipeppr (rad alert!)

## Gcode Basics
- may it RIP

# Footnotes

1. [Five Axis](http://ekswhyzee.com/index.php/project/tinyfive/), [Metal Laser Cutter](http://ekswhyzee.com/index.php/project/mako/), [and here](http://3dfablight.com/), [Dual Head 3D Printer](http://openassemblies.com/index.php/fdm4md/), and [Ongoing Robot Arm Adventure](http://openassemblies.com/index.php/rsea/)   
2. Asides will be relegated to the footnotes when not strictly necessary.
3. Design and Build
4. Things work very well when they are designed to do only one-thing. For example, vise grips *will* turn just about anything, but no one would say they are *good* at turning *anything*. A building designed for Helsinki may not make so much sense in Dubai. In another example, a laser cutter has a motion system that is optimized for speed, and takes advantage of the fact that it has very little mass to move around (a few mirrors) in order to carry through on this optimization. A milling machine is engineered for stiffness, and trades speed for the mass required to carry through on that optimization. In trying to have one motion system do all of these things, we'll go a little 'soft' in the middle, but we'll also be able to offer a lot of variety in a single system.
5. Relative Scaling: 10^4 of length scale is a common machine, 10^6 is good - lookup slocum ?
6. ~ 305x610mm 
7. ~ 127mm
8. So I want an H-style layout, because I want to keep the machine small relative it's total work area. One of the biggest drawbacks with an H-machine is that the two sides of the Y-axis are not always set up parallel. The result is what's called 'racking' - i.e. imagine opening a screen door, and the top or bottom exhibits more friction - the 'jam' that this causes happens in CNC Machines as well. A drawing. By cutting both Y-axis rails out of the same 'frame', Jakob gets around this issue - the parallelness of the two rails is a mirror of the parallelness of the machine which cut them. It makes it a bit bulletproof to novice assemblers. He has also done a really good job of keeping the X-axis loads really close to the Y-axis rails (so, a small structural loop). 
9. AKA Acetal, AKA POM

to be linked - dan gelbart
talk about resolution vs. accuracy - repeatability vs absolute accuracty - global vs. local resolutions 